package org.processmining.processtree.arrays.importing;

import java.io.File;
import java.io.InputStream;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.arrays.impl.ProcessTreeArrayImpl;

@Plugin(name = "Import Process Tree Array", parameterLabels = { "Filename" }, 
returnLabels = { "Process Tree Array" }, returnTypes = { ProcessTreeArray.class })
@UIImportPlugin(description = "Process Tree Array files", extensions = { "ptmla" })
public class ImportProcessTreeArray extends AbstractImportPlugin {

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		ProcessTreeArray pta = new ProcessTreeArrayImpl();
		File file = getFile();
		String parent = (file == null ? null : file.getParent());
		pta.importFromStream(context, input, parent);
		return pta;
	}
}
