package org.processmining.processtree.configuration;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.processtree.configuration.controlflow.impl.ControlFlowConfigurationImport;
import org.processmining.processtree.configuration.impl.ConfigurationImpl;

@Plugin(name = "Import Process Tree Configuration", parameterLabels = { "Filename" }, returnLabels = { "Process Tree Configuration" }, returnTypes = { Configuration.class })
@UIImportPlugin(description = "Process Tree Configuration files", extensions = { "ptcf" })
public class ConfigurationImport extends AbstractImportPlugin{

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		return privateImportFromStream(context, input, filename, fileSizeInBytes);
	}
	
	private Configuration privateImportFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes) throws IOException{
		String xml = "";
		BufferedReader read = new BufferedReader(new InputStreamReader(input));
		String line = "";
		while((line = read.readLine()) != null){
			xml += line;
		}
		Configuration conf = new ConfigurationImpl();
		conf.setControlFlowConfiguration(ControlFlowConfigurationImport.importer(xml));
		return conf;
	}

}
