package org.processmining.processtree.configuration;

import java.util.List;

import org.processmining.framework.util.Pair;

/**
 * @author DSchunse
 */
public interface ConfigurationIterator {
	/**
	 * This function determines if there is another configuration
	 * @return
	 * @throws Exception
	 */
	boolean hasNext() throws Exception;
	
	/**
	 * Return the next configuration
	 * @return
	 * @throws Exception
	 */
	Configuration getNext() throws Exception;
	
	/**
	 * Return a subdivision of the search space which can be used to distribute the iteration through the 
	 * @return
	 * @throws Exception
	 */
	List<Pair<Object, Object>> getSubdivisions(int divisions) throws Exception;
}
