package org.processmining.processtree.configuration.controlflow;

import java.util.Map;
import java.util.Set;
import java.util.UUID;

import org.processmining.processtree.ProcessTree;

public interface ControlFlowConfigurationInstantiater {
	/**
	 * Instantiates a Process Tree with the given Control-Flow Configuration
	 * @param tree
	 * @param conf
	 * @return
	 */
	ProcessTree instantiate(ProcessTree tree, ControlFlowConfiguration conf);
	
	/**
	 * Instantiates a Process Tree with the given Control-Flow Configuration and makes the configuration complete if requested
	 * @param tree
	 * @param conf
	 * @param makeConfigurationComplete
	 * @return
	 */
	ProcessTree instantiate(ProcessTree tree, ControlFlowConfiguration conf, Boolean makeConfigurationComplete);
	
	/**
	 * Returns a map to indicate which nodes have been substituted by which taus
	 * @return
	 */
	Map<UUID, Set<UUID>> getMappingHiddenNodesToTaus();
}
