package org.processmining.processtree.configuration.controlflow;

import java.util.List;

import org.processmining.framework.util.Pair;

public interface ControlFlowConfigurationIterator {
	/**
	 * This function determines if there is another configuration
	 * @return
	 * @throws Exception
	 */
	boolean hasNext() throws Exception;
	
	/**
	 * Return the next configuration
	 * @return
	 * @throws Exception
	 */
	ControlFlowConfiguration getNext() throws Exception;
	
	/**
	 * Resets the iterator to the initial state
	 */
	void reset();
	
	/**
	 * Return a subdivision of the search space which can be used to distribute the iteration through the 
	 * @return
	 * @throws Exception
	 */
	List<Pair<Object, Object>> getSubdivisions(int divisions) throws Exception;
}
