package org.processmining.processtree.configuration.data;

import java.util.Map;
import java.util.Set;
import java.util.UUID;

public interface DataConfiguration {
	
	public void setSelectedExpression(UUID edge, UUID expression);
	
	public void addNonSelectedExpression(UUID edge, UUID expression);
	
	public void addRemovedRead(UUID node, UUID variable);
	
	public void addNonRemovedRead(UUID node, UUID variable);
	
	public void addRemovedWritten(UUID node, UUID variable);
	
	public void addNonRemovedWritten(UUID node, UUID variable);
	
	public UUID getSelectedExpression(UUID edge);
	
	public Set<UUID> getNonSelectedExpression(UUID edge);
	
	public Set<UUID> getRemovedRead(UUID node);
	
	public Set<UUID> getNonRemovedRead(UUID node);
	
	public Set<UUID> getRemovedWritten(UUID node);
	
	public Set<UUID> getNonRemovedWritten(UUID node);
	
	public Map<UUID, UUID> getSelectedExpressions();
	
	public Map<UUID, Set<UUID>> getNonSelectedExpressions();
	
	public Map<UUID, Set<UUID>> getRemovedRead();
	
	public Map<UUID, Set<UUID>> getNonRemovedRead();
	
	public Map<UUID, Set<UUID>> getRemovedWritten();
	
	public Map<UUID, Set<UUID>> getNonRemovedWritten();

}
