package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.configuration.Configuration;

/**
 * Connects a {@link Configuration} object to a single {@link ProcessTreeArray} using
 * a weak connection (e.g. the connection is removed whenever one of these is
 * removed, but the other object is not removed).
 * 
 * @author jbuijs
 * 
 */
@SuppressWarnings("deprecation")
public class ConfigurationToProcessTreeArrayConnection extends AbstractConnection {

	public static final String PROCESSTREEARRAY = "PROCESSTREEARRAY";

	public static final String CONFIGURATION = "CONFIGURATION";

	public ConfigurationToProcessTreeArrayConnection(Configuration configuration, ProcessTreeArray processTreeArray) {
		super("Configuration to Process Tree Array");
		put(PROCESSTREEARRAY, processTreeArray);
		put(CONFIGURATION, configuration);
	}

}
