package org.processmining.processtree.conversion.yawl;

import java.util.List;


public class CMapping{
	String XML;
	
	public CMapping(String fileName){
		initialise(fileName);
	}
	
	public String getXML(){
		return XML;
	}
	
	public void append(String xml){
		XML += xml;
	}
	
	public void appendSplits(List<String> xml){
		append("\t\t<splits>\n");
		for(String split: xml){
			append(split);
		}
		append("\t\t</splits>\n");
	}
	
	public void appendJoins(List<String> xml){
		append("\t\t<joins>\n");
		for(String join: xml){
			append(join);
		}
		append("\t\t</joins>\n");
	}
	
	public void initialise(String fileName){
		XML = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n";
		XML += "<tns:CMAP xmlns:tns=\"http://www.processconfiguration.com/CMAP\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" qml=\"default.qml\" xsi:schemaLocation=\"http://www.processconfiguration.com/CMAP CMAP.xsd\">\n";
		XML += "\t<c-yawl yawl=\"" + fileName + "\">\n";
	}
	
	public void finalise(){
		XML += "\t\t<rems/>\n";
		XML += "\t\t<nofis/>\n";
		XML += "\t</c-yawl>\n";
		XML += "</tns:CMAP>\n";
	}
}
