package org.processmining.processtree.conversion.yawl;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "YAWL Domain Configuration Export", returnLabels = {}, returnTypes = {}, parameterLabels = { "YAWL Domain Configuration",
"File" }, userAccessible = true)
@UIExportPlugin(description = "YAWL Domain Configuration", extension = "dcl")
public class ExportDomainConfiguration {
	@PluginVariant(variantLabel = "YAWL Domain Configuration Export", requiredParameterLabels = { 0, 1 })
	public void exportDefault(UIPluginContext context, DomainConfiguration domainConfiguration, File file) throws IOException {
		exportPrivate(context, domainConfiguration, file);
	}
	
	public void exportDefault(PluginContext context, DomainConfiguration domainConfiguration, File file) throws IOException {
		exportPrivate(context, domainConfiguration, file);
	}

	private void exportPrivate(PluginContext context, DomainConfiguration domainConfiguration, File file) throws IOException {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file)));
		bw.write(domainConfiguration.getXML());
		bw.close();
	}
}
