package org.processmining.processtree.conversion.yawl;

import java.io.File;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.yawlfoundation.yawl.editor.specification.SpecificationArchiveHandler;
import org.yawlfoundation.yawl.editor.specification.SpecificationModel;

@Plugin(name = "YAWL Specification Export", returnLabels = {}, returnTypes = {}, parameterLabels = { "YAWL Specification",
"File" }, userAccessible = true)
@UIExportPlugin(description = "YAWL files", extension = "yawl")
public class ExportYAWLSpecification {
	@PluginVariant(variantLabel = "YAWL Export", requiredParameterLabels = { 0, 1 })
	public void exportDefault(UIPluginContext context, SpecificationModel specification, File file) {
		exportPrivate(context, specification, file);
	}
	
	public void exportDefault(PluginContext context, SpecificationModel specification, File file) {
		exportPrivate(context, specification, file);
	}

	private void exportPrivate(PluginContext context, SpecificationModel specification, File file) {
		specification.setFileName(file.getPath());
		SpecificationArchiveHandler.getInstance().saveUpdatingGUI(specification);
	}
}
