package org.processmining.processtree.conversion.yawl;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.yawlfoundation.yawl.editor.net.NetGraphModel;
import org.yawlfoundation.yawl.editor.specification.SpecificationModel;

public class VisualiseYAWLSpecification {
	@Plugin(name = "Visualize YAWL Specification", returnLabels = { "Visualized YAWL Specification" }, returnTypes = { JComponent.class }, parameterLabels = {
	"Process tree" }, userAccessible = true)
	@Visualizer
	public JComponent visualize(PluginContext context, SpecificationModel specification) {
		JTabbedPane tabPane = new JTabbedPane();
		tabPane.setName("Model: " + specification.getName() + " Author: " + specification.getAuthor());
		for(NetGraphModel netGraphModel: specification.getNets()){
			JScrollPane pane = new JScrollPane(netGraphModel.getGraph());
			tabPane.addTab(netGraphModel.getName(), pane);
		}
		return tabPane;
	}
}
