package org.processmining.processtree.editor.editorpanel;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JTextField;

import org.processmining.processtree.Expression;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.Variable;
import org.processmining.processtree.editor.interaction.GraphMouseListener;
import org.processmining.processtree.impl.ExpressionImpl;

public class EditorActionListenerAddExpression implements EditorActionListener{
	ProcessTree tree;
	GraphMouseListener graphMouseListener;
	JTextField expressionField;
	
	public EditorActionListenerAddExpression(ProcessTree tree, GraphMouseListener graphMouseListener, JTextField expressionField){
		this.tree = tree;
		this.graphMouseListener = graphMouseListener;
		this.expressionField = expressionField;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		String expression = expressionField.getText();
		// parse the expression to get the variables
		String[] subexpressions = expression.split("=");
		// now we have to check on variable names, check from large to small since this way we cannot
		// have problems with subnames
		List<Variable> vars = new ArrayList<>();
		for(String s: subexpressions){
			if(!s.equalsIgnoreCase("")){
				// now we have to make sure that we have the beginning, i.e., we have a variable
				if(s.lastIndexOf("(") >= s.lastIndexOf(")")){
					// we have the right clause
					Variable likelyVariable = null;
					for(Variable var: tree.getVariables()){
						if(s.contains(var.getName())){
							// now check with the likelyVariable
							if(likelyVariable != null && var.getName().contains(likelyVariable.getName())){
								likelyVariable = var;
							}
							if(likelyVariable == null){
								likelyVariable = var;
							}
						}
					}
					if(likelyVariable != null){
						vars.add(likelyVariable);
					}
					
				}
			}
		}
		// now create the expression
		Variable[] usedVars = new Variable[vars.size()];
		int index = 0;
		for(Variable var: vars){
			usedVars[index] = var;
			index++;
		}
		Expression expr = new ExpressionImpl(expression, expression, usedVars);
		tree.addExpression(expr);
		expressionField.setText("");
		graphMouseListener.mousePressed(null);
	}
	
	public boolean isEnabled(){
		return true;
	}
}
