package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Originator;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractOriginator;

public class PtmlGroup extends PtmlOriginator {
	
	public final static String TAG = "group";
	
	public PtmlGroup(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Originator> originatorMap) {
		Originator originator = new AbstractOriginator.Group(id, name);
		unmarshall(tree, originatorMap, originator);
	}
	
	public boolean equals(Object o) {
		return ((o instanceof PtmlGroup) && (id.equals(((PtmlGroup) o).id)));
	}
	
	public int hashCode() {
		return id.hashCode();
	}
}