package org.processmining.processtree.ptml;

import java.util.UUID;

import org.xmlpull.v1.XmlPullParser;

public class PtmlId extends PtmlElement {

	protected UUID id;
	
	public PtmlId(String tag, UUID id) {
		super(tag);
		this.id = id;
	}
	
	protected void importAttributes(XmlPullParser xpp, Ptml ptml) {
		super.importAttributes(xpp, ptml);
		importId(xpp, ptml);
	}

	private void importId(XmlPullParser xpp, Ptml ptml) {
		String value = xpp.getAttributeValue(null, "id");
		if (value != null) {
			id = UUID.fromString(value);
		}
		ptml.log(id != null ? value : "<no id>");
	}

	protected String exportAttributes(Ptml ptml) {
		return super.exportAttributes(ptml) + exportId(ptml);
	}

	private String exportId(Ptml ptml) {
		if (id != null) {
			return exportAttribute("id", id.toString(), ptml);
		}
		return "";
	}
	
}
