package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Event;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractEvent;

public class PtmlMessage extends PtmlEvent {
	
	public final static String TAG = "messageEvent";
	
	public PtmlMessage(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Node> map) {
		Event event = new AbstractEvent.Message(id, name, message);
		unmarshall(tree, map, event);
	}

	public void marshall(ProcessTree tree, Node node) {
		super.marshall(tree, node);
		if (node instanceof Event.Message) {
			message = ((Event.Message) node).getMessage();
		}
	}
}