package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;

public abstract class PtmlNode extends PtmlProcessTreeElement {
	
	public PtmlNode(String tag, UUID id) {
		super(tag, id);
	}

	public abstract void unmarshall(ProcessTree tree, Map<UUID, Node> map);
	
	public void unmarshall(ProcessTree tree, Map<UUID, Node> map, Node node) {
		tree.addNode(node);
		node.setProcessTree(tree);
		map.put(id, node);
		if(propertyIndependent != null){
			propertyIndependent.unmarshall(node);
		}
		if(propertyDependent != null){
			propertyDependent.unmarshall(node);
		}
	}
}
