package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.Variable;
import org.processmining.processtree.impl.VariableImpl;

public class PtmlVariable extends PtmlProcessTreeElement {

	public final static String TAG = "variable";

	public PtmlVariable(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Variable> variableMap) {
		if (name != null) {
			Variable variable = new VariableImpl(id, name);
			variableMap.put(id, variable);
			tree.addVariable(variable);
			if(propertyIndependent != null){
				propertyIndependent.unmarshall(variable);
			}
			if(propertyDependent != null){
				propertyDependent.unmarshall(variable);
			}
		}
	}
	
	public void marshall(ProcessTree tree, Map<Variable, UUID> variableMap, Variable variable) {
		marshall(tree, variable);
		variableMap.put(variable, id);
	}
}
