package org.processmining.processtree.visualization.data;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import org.processmining.framework.util.Pair;
import org.processmining.processtree.Node;
import org.processmining.processtree.Variable;

public class VariableApplyActionListener implements ActionListener{
	Map<Pair<Node, Variable>, VariableCell> variableCells;
	
	public VariableApplyActionListener(Map<Pair<Node, Variable>, VariableCell> variableCells){
		this.variableCells = variableCells;
	}
	
	public void actionPerformed(ActionEvent e) {
		// when we have clicked on apply we have to serialise all the choices to the tasks and variables
		// note: we have a total mapping so we can just check all combinations
		for(Pair<Node, Variable> varCell : variableCells.keySet()){
			Node n = varCell.getFirst();
			Variable var = varCell.getSecond();
			n.getReadVariables().remove(var);
			n.getWrittenVariables().remove(var);
			n.getRemovableReadVariables().remove(var);
			n.getRemovableWrittenVariables().remove(var);
			// now add them again accordingly
			if(variableCells.get(varCell).getRead().isSelected()){
				n.getReadVariables().add(var);
			}
			if(variableCells.get(varCell).getWrite().isSelected()){
				n.getWrittenVariables().add(var);
			}
			if(variableCells.get(varCell).getRemRead().isSelected()){
				n.getRemovableReadVariables().add(var);
			}
			if(variableCells.get(varCell).getRemWrite().isSelected()){
				n.getRemovableWrittenVariables().add(var);
			}
			
		}
	}

}
